# Class SnpEffCmdEff

java.lang.Object
org.snpeff.SnpEff
org.snpeff.snpEffect.commandLine.SnpEffCmdEff

All Implemented Interfaces:
  `CommandLine, VcfAnnotator`

public class SnpEffCmdEff extends SnpEff implements VcfAnnotator
Command line program: Predict variant effects

Author:
  Pablo Cingolani

## Nested Class Summary

### Nested classes/interfaces inherited from class SnpEff

`SnpEff.GeneDatabaseFormat, SnpEff.InputFormat, SnpEff.OutputFormat`

## Field Summary

Fields
Modifier and Type
Field
Description
`static final String`
`DEFAULT_SUMMARY_CSV_FILE`
`static final String`
`DEFAULT_SUMMARY_GENES_FILE`
`static final String`
`DEFAULT_SUMMARY_HTML_FILE`
`static final int`
`SHOW_EVERY`
`static final String`
`SUMMARY_CSV_TEMPLATE`
`static final String`
`SUMMARY_GENES_TEMPLATE`
`static final String`
`SUMMARY_TEMPLATE`
`static final String`
`TEMPLATES_DIR`

### Fields inherited from class SnpEff

`args, BUILD, BUILD_DATE, canonical, canonicalFile, command, COMMAND_LINE_WIDTH, config, configFile, configOverride, customIntervalFiles, dataDir, debug, DEFAULT_COMMAND, download, expandIub, genome, genomeVer, help, hgvs, hgvsForce, hgvsOld, hgvsOneLetterAa, hgvsShift, hgvsTrId, interaction, log, maxTranscriptSupportLevel, motif, multiThreaded, nextProt, nextProtKeepAllTrs, noGenome, numWorkers, onlyProtein, onlyRegulation, onlyTranscriptsFile, output, quiet, regulationTracks, REVISION, saveOutput, shiftArgs, snpEffCmd, SOFTWARE_NAME, spliceRegionExonSize, spliceRegionIntronMax, spliceRegionIntronMin, spliceSiteSize, strict, suppressOutput, tags, tagsNo, testing, treatAllAsProteinCoding, upDownStreamLength, verbose, VERSION, VERSION_AUTHOR, VERSION_BUILD, VERSION_MAJOR, VERSION_SHORT`

## Constructor Summary

Constructors
Constructor
Description
`SnpEffCmdEff()`

## Method Summary

Modifier and Type
Method
Description
`boolean`
`addHeaders(VcfFileIterator vcfFile)`
Add annotation headers to VCF file
`boolean`
`annotate(String inputFile, String outputFile)`
Annotate: Calculate the effect of variants and show results
`boolean`
`annotate(VcfEntry vcfEntry)`
Annotate a VCF entry
`boolean`
`annotateFinish(VcfFileIterator vcfFile)`
Finish annotations and create reports
`protected void`
`annotateInit(String outputFile)`
Calculate the effect of variants and show results
`boolean`
`annotateInit(VcfFileIterator vcfFile)`
Initialize annotator: This method is called after vcfFile is opened, but before the header is output.
`VariantEffectStats`
`getChangeEffectResutStats()`
`int`
`getTotalErrs()`
`VariantStats`
`getvariantStats()`
`void`
`parseArgs(String[] args)`
Parse command line arguments
`HashMap<String,String>`
`reportValues()`
Additional values to be reported
`boolean`
`run()`
Run according to command line options
`List<VcfEntry>`
`run(boolean createList)`
Run according to command line options
`void`
`setFormatVersion(EffFormatVersion formatVersion)`
`void`
`usage(String message)`
Show 'usage;' message and exit with an error code '-1'

### Methods inherited from class SnpEff

`addRegulationTrack, canonical, cmd, commandLineStr, filterTags, getArgs, getConfig, getConfigFile, getOutput, isOpt, load, loadConfig, loadCustomFile, loadDb, loadMarkers, main, run, setCanonical, setConfig, setConfigFile, setDebug, setGenomeVer, setLog, setNextProt, setNextProtKeepAllTrs, setShiftHgvs, setSpliceSiteSize, setSupressOutput, setTesting, setUpDownStreamLength, setVerbose, usageDb, usageGeneric, usageGenericAndDb`

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface CommandLine

`getArgs`

### Methods inherited from interface VcfAnnotator

`setConfig, setDebug, setVerbose`

## Field Details

### TEMPLATES_DIR

public static final String TEMPLATES_DIR

See Also:
  - Constant Field Values

### SUMMARY_TEMPLATE

public static final String SUMMARY_TEMPLATE

See Also:
  - Constant Field Values

### SUMMARY_CSV_TEMPLATE

public static final String SUMMARY_CSV_TEMPLATE

See Also:
  - Constant Field Values

### SUMMARY_GENES_TEMPLATE

public static final String SUMMARY_GENES_TEMPLATE

See Also:
  - Constant Field Values

### DEFAULT_SUMMARY_HTML_FILE

public static final String DEFAULT_SUMMARY_HTML_FILE

See Also:
  - Constant Field Values

### DEFAULT_SUMMARY_CSV_FILE

public static final String DEFAULT_SUMMARY_CSV_FILE

See Also:
  - Constant Field Values

### DEFAULT_SUMMARY_GENES_FILE

public static final String DEFAULT_SUMMARY_GENES_FILE

See Also:
  - Constant Field Values

### SHOW_EVERY

public static final int SHOW_EVERY

See Also:
  - Constant Field Values

## Constructor Details

### SnpEffCmdEff

public SnpEffCmdEff()

## Method Details

### addHeaders

public boolean addHeaders(VcfFileIterator vcfFile)
Description copied from interface: `VcfAnnotator`
Add annotation headers to VCF file

Specified by:
  `addHeaders` in interface `VcfAnnotator`
Returns:
  true if OK, false on error

### annotate

public boolean annotate(String inputFile, String outputFile)
Annotate: Calculate the effect of variants and show results

### annotate

public boolean annotate(VcfEntry vcfEntry)
Annotate a VCF entry

Specified by:
  `annotate` in interface `VcfAnnotator`
Returns:
  true if the entry was annotated

### annotateFinish

public boolean annotateFinish(VcfFileIterator vcfFile)
Finish annotations and create reports

Specified by:
  `annotateFinish` in interface `VcfAnnotator`
Returns:
  true if OK, false on error

### annotateInit

protected void annotateInit(String outputFile)
Calculate the effect of variants and show results

### annotateInit

public boolean annotateInit(VcfFileIterator vcfFile)
Description copied from interface: `VcfAnnotator`
Initialize annotator: This method is called after vcfFile is opened, but before the header is output. The first vcfEntry might have (and often has) already been read from the file.

Specified by:
  `annotateInit` in interface `VcfAnnotator`
Returns:
  true if OK, false on error

### getChangeEffectResutStats

public VariantEffectStats getChangeEffectResutStats()

### getTotalErrs

public int getTotalErrs()

### getvariantStats

public VariantStats getvariantStats()

### parseArgs

public void parseArgs(String[] args)
Parse command line arguments

Specified by:
  `parseArgs` in interface `CommandLine`
Overrides:
  `parseArgs` in class `SnpEff`

### reportValues

public HashMap<String,String> reportValues()
Description copied from class: `SnpEff`
Additional values to be reported

Overrides:
  `reportValues` in class `SnpEff`

### run

public boolean run()
Run according to command line options

Specified by:
  `run` in interface `CommandLine`
Overrides:
  `run` in class `SnpEff`

### run

public List<VcfEntry> run(boolean createList)
Run according to command line options

### setFormatVersion

public void setFormatVersion(EffFormatVersion formatVersion)

### usage

public void usage(String message)
Show 'usage;' message and exit with an error code '-1'

Specified by:
  `usage` in interface `CommandLine`
Overrides:
  `usage` in class `SnpEff`
Parameters:
  `message` -